!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   spb :    A singularly perturbed BVP
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      DOUBLE PRECISION u1,u2,eps,lambda

       u1 = U(1)
       u2 = U(2)
       eps= PAR(2)
       lambda =PAR(3)

       F(1) = u2 
       F(2) = lambda * ( u1*(u1**2-1)*u2 + u1 ) / eps 

      END SUBROUTINE FUNC

      SUBROUTINE STPNT(NDIM,U,PAR,x)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: x

      DOUBLE PRECISION gamma,eps,lambda,s

       gamma = 1.2d0
       eps   = 0.5d0
       lambda= 0.d0

       PAR(1) = gamma
       PAR(2) = eps
       PAR(3) = lambda

       s = gamma-1.5d0
       U(1) = 1.5d0 + s*x
       U(2) = s

      END SUBROUTINE STPNT

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

       FB(1) = U0(1)-1.5d0
       FB(2) = U1(1)-PAR(1) 

      END SUBROUTINE BCND

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT

      SUBROUTINE PVLS
      END SUBROUTINE PVLS

